<template>
	<q-page padding>
		<q-toolbar>
			<q-toolbar-title>{{$t('department')}}</q-toolbar-title>

			<q-btn :flat="cardLayout" round dense color="primary" icon="view_list" @click="toggleLayout" />
			<q-btn :flat="!cardLayout" round dense color="primary" icon="map" @click="toggleLayout" />
		</q-toolbar>
		<div v-if="dataLoaded">
			<departments-cards v-if="cardLayout" :departments="departments" @browseTo="browseTo" />
			<departments-list v-if="!cardLayout" :departments="departments" @browseTo="browseTo" />
		</div>
	</q-page>
</template>

<script>
	import departmentsCards from "components/departmentsCards";
	import departmentsList from "components/departmentsList";
	import fetchFn from "../js/fetch";

	export default {
		name: "departments",
		components: {
			departmentsCards,
			departmentsList
		},
		data() {
			return {
				dataLoaded: false,
				APIURL: "http://localhost:3000",
				departments: [],
				cardLayout: true
			};
		},
		methods: {
			browseTo(depId) {
				this.$router.push({ name: "department", params: { id: depId } });
			},
			toggleLayout() {
				this.cardLayout = !this.cardLayout;
				this.$q.cookies.set("departmentsLayout", this.cardLayout, {
					expires: 365,
					path: "/"
				});
			},
			loadDepData: async function() {
				try {
					this.departments = await fetchFn.getDepartments();
					this.dataLoaded = true;
				} catch (e) {
					this.$alert(
						this.$i18n.t("error.unexpected"),
						this.$i18n.t("error.error"),
						"error"
					);
				}
			}
		},
		created() {
			// cardlayout?
			if (this.$q.cookies.has("departmentsLayout")) {
				this.cardLayout = this.$q.cookies.get("departmentsLayout");
			}

			this.loadDepData();
		}
	};
</script>

<style lang="css" scoped>
	h1 {
		font-size: 3em;
	}
</style>
